diff --git a/Makefile b/Makefile
index fa979e0..52aa60d 100644
--- a/Makefile
+++ b/Makefile
@@ -30,7 +30,6 @@ check:
 	@(cd cpufreq; $(MAKE) check)
 	@(cd cpuhotplug; $(MAKE) check)
 	@(cd cpuidle; $(MAKE) check)
-	@(cd sched_mc; $(MAKE) check)
 #	@(cd suspend; $(MAKE) check)
 	@(cd thermal; $(MAKE) check)
 #	@(cd powertop; $(MAKE) check)
@@ -39,7 +38,6 @@ uncheck:
 	@(cd cpufreq; $(MAKE) uncheck)
 	@(cd cpuhotplug; $(MAKE) uncheck)
 	@(cd cpuidle; $(MAKE) uncheck)
-	@(cd sched_mc; $(MAKE) uncheck)
 #	@(cd suspend; $(MAKE) uncheck)
 	@(cd thermal; $(MAKE) uncheck)
 
diff --git a/README b/README
index a22a3c8..d689e11 100644
--- a/README
+++ b/README
@@ -8,5 +8,4 @@ If you want the test suite to continue when one error has been found, do:
 
 If you want to run a subset of the tests, do:
 
-	make -C sched_mc check
 	make -C cpufreq check
diff --git a/sched_mc/Android.mk b/sched_mc/Android.mk
deleted file mode 100644
index f9f9d90..0000000
--- a/sched_mc/Android.mk
+++ /dev/null
@@ -1,18 +0,0 @@
-include $(call all-subdir-makefiles)
-LOCAL_PATH:= $(call my-dir)
-
-module_name = sched
-
-define $(module_name)_add_executable
-    include $(CLEAR_VARS)
-    LOCAL_MODULE_TAGS := optional 
-    LOCAL_MODULE_CLASS := tests
-    LOCAL_MODULE := $1.sh
-    systemtarball: $1.sh
-    LOCAL_SRC_FILES := $1.sh
-    LOCAL_MODULE_PATH := $(TARGET_OUT_OPTIONAL_EXECUTABLES)/pm-qa/$(module_name)_mc
-    include $(BUILD_PREBUILT)
-endef
-
-test_num := 01 02 03 04
-$(foreach item,$(test_num),$(eval $(call $(module_name)_add_executable, $(module_name)_$(item))))
diff --git a/sched_mc/Makefile b/sched_mc/Makefile
deleted file mode 100644
index a90620c..0000000
--- a/sched_mc/Makefile
+++ /dev/null
@@ -1,25 +0,0 @@
-#
-# PM-QA validation test suite for the power management on Linux
-#
-# Copyright (C) 2011, Linaro Limited.
-#
-# This program is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License
-# as published by the Free Software Foundation; either version 2
-# of the License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-#
-# Contributors:
-#     Daniel Lezcano <daniel.lezcano@linaro.org> (IBM Corporation)
-#       - initial API and implementation
-#
-
-include ../Test.mk
\ No newline at end of file
diff --git a/sched_mc/sched_01.sh b/sched_mc/sched_01.sh
deleted file mode 100755
index d4414b6..0000000
--- a/sched_mc/sched_01.sh
+++ /dev/null
@@ -1,32 +0,0 @@
-#!/bin/bash
-#
-# PM-QA validation test suite for the power management on Linux
-#
-# Copyright (C) 2011, Linaro Limited.
-#
-# This program is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License
-# as published by the Free Software Foundation; either version 2
-# of the License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-#
-# Contributors:
-#     Daniel Lezcano <daniel.lezcano@linaro.org> (IBM Corporation)
-#       - initial API and implementation
-#
-
-# URL : https://wiki.linaro.org/WorkingGroups/PowerManagement/Doc/QA/Scripts#sched_mc_01
-
-source ../include/functions.sh
-
-FILES="sched_mc_power_savings"
-
-check_sched_mc_files $FILES
diff --git a/sched_mc/sched_01.txt b/sched_mc/sched_01.txt
deleted file mode 100644
index 6783a3a..0000000
--- a/sched_mc/sched_01.txt
+++ /dev/null
@@ -1 +0,0 @@
-test the presence of the 'sched_mc_power_savings' file
diff --git a/sched_mc/sched_02.sh b/sched_mc/sched_02.sh
deleted file mode 100755
index c7cbc26..0000000
--- a/sched_mc/sched_02.sh
+++ /dev/null
@@ -1,38 +0,0 @@
-#!/bin/bash
-#
-# PM-QA validation test suite for the power management on Linux
-#
-# Copyright (C) 2011, Linaro Limited.
-#
-# This program is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License
-# as published by the Free Software Foundation; either version 2
-# of the License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-#
-# Contributors:
-#     Daniel Lezcano <daniel.lezcano@linaro.org> (IBM Corporation)
-#       - initial API and implementation
-#
-
-# URL : https://wiki.linaro.org/WorkingGroups/PowerManagement/Doc/QA/Scripts#sched_mc_02
-
-source ../include/functions.sh
-
-check_physical_package_id() {
-
-    local package_id=$CPU_PATH/$1/topology/physical_package_id
-    local val=$(cat $package_id)
-
-    check "topology is enabled" "test \"$val\" != \"-1\""
-}
-
-for_each_cpu check_physical_package_id || exit 1
diff --git a/sched_mc/sched_02.txt b/sched_mc/sched_02.txt
deleted file mode 100644
index 5493610..0000000
--- a/sched_mc/sched_02.txt
+++ /dev/null
@@ -1 +0,0 @@
-test the topology is implemented in the kernel
diff --git a/sched_mc/sched_03.sh b/sched_mc/sched_03.sh
deleted file mode 100755
index 6520ce5..0000000
--- a/sched_mc/sched_03.sh
+++ /dev/null
@@ -1,33 +0,0 @@
-#!/bin/bash
-#
-# PM-QA validation test suite for the power management on Linux
-#
-# Copyright (C) 2011, Linaro Limited.
-#
-# This program is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License
-# as published by the Free Software Foundation; either version 2
-# of the License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-#
-# Contributors:
-#     Daniel Lezcano <daniel.lezcano@linaro.org> (IBM Corporation)
-#       - initial API and implementation
-#
-
-# URL : https://wiki.linaro.org/WorkingGroups/PowerManagement/Doc/QA/Scripts#sched_mc_03
-
-source ../include/functions.sh
-
-FILES="core_id core_siblings core_siblings_list physical_package_id \
-thread_siblings thread_siblings_list"
-
-for_each_cpu check_topology_files $FILES
diff --git a/sched_mc/sched_03.txt b/sched_mc/sched_03.txt
deleted file mode 100644
index b9e8d6f..0000000
--- a/sched_mc/sched_03.txt
+++ /dev/null
@@ -1 +0,0 @@
-test the topology files are present
diff --git a/sched_mc/sched_04.sh b/sched_mc/sched_04.sh
deleted file mode 100755
index f9266e8..0000000
--- a/sched_mc/sched_04.sh
+++ /dev/null
@@ -1,70 +0,0 @@
-#!/bin/bash
-#
-# PM-QA validation test suite for the power management on Linux
-#
-# Copyright (C) 2011, Linaro Limited.
-#
-# This program is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License
-# as published by the Free Software Foundation; either version 2
-# of the License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-#
-# Contributors:
-#     Daniel Lezcano <daniel.lezcano@linaro.org> (IBM Corporation)
-#       - initial API and implementation
-#
-
-# URL : https://wiki.linaro.org/WorkingGroups/PowerManagement/Doc/QA/Scripts#sched_mc_04
-
-source ../include/functions.sh
-
-check_change() {
-    local val=$1
-    local path=$2
-
-    echo $val > $path
-}
-
-check_invalid_change() {
-
-    local val=$1
-    local path=$2
-
-    echo $val > $path
-    if [ "$?" != "0" ]; then
-	return 0
-    fi
-
-    return 1
-}
-
-check_sched_mc_change() {
-
-    local path=$CPU_PATH/sched_mc_power_savings
-    local oldval=$(cat $path)
-
-    check "setting value to 0" check_change 0 $path
-    check "setting value to 1" check_change 1 $path
-    check "setting value to 2" check_change 2 $path
-    check "setting invalid value to 3" check_invalid_change 3 $path
-    check "setting invalid value to -1" check_invalid_change -1 $path
-
-    echo $oldval > $path
-}
-
-if [ $(id -u) != 0 ]; then
-    log_skip "run as non-root"
-    exit 0
-fi
-
-# check_sched_mc_files sched_mc_power_savings || exit 1
-check_sched_mc_change
diff --git a/sched_mc/sched_04.txt b/sched_mc/sched_04.txt
deleted file mode 100644
index 7f5ed4a..0000000
--- a/sched_mc/sched_04.txt
+++ /dev/null
@@ -1 +0,0 @@
-test the change are effective for the 'sched_mc_power_savings' file
diff --git a/sched_mc/sched_sanity.sh b/sched_mc/sched_sanity.sh
deleted file mode 100755
index 1b1b58b..0000000
--- a/sched_mc/sched_sanity.sh
+++ /dev/null
@@ -1,35 +0,0 @@
-#!/bin/bash
-#
-# PM-QA validation test suite for the power management on Linux
-#
-# Copyright (C) 2011, Linaro Limited.
-#
-# This program is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License
-# as published by the Free Software Foundation; either version 2
-# of the License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-#
-# Contributors:
-#     Daniel Lezcano <daniel.lezcano@linaro.org> (IBM Corporation)
-#       - initial API and implementation
-#
-
-source ../include/functions.sh
-
-check_sched_mc_sysfs_entry() {
-
-    local filepath=$CPU_PATH/sched_mc_power_savings
-
-    test -f $filepath && return 1 || return 0
-}
-
-check_sched_mc_sysfs_entry
diff --git a/sched_mc/sched_sanity.txt b/sched_mc/sched_sanity.txt
deleted file mode 100644
index c79c23e..0000000
--- a/sched_mc/sched_sanity.txt
+++ /dev/null
@@ -1 +0,0 @@
-sched_mc is not enabled. Skipping all sched_mc tests...