diff --git a/Makefile b/Makefile
new file mode 100644
index 0000000..a7e7898
--- /dev/null
+++ b/Makefile
@@ -0,0 +1,12 @@
+CFLAGS?=-g -Wall
+CC?=gcc
+
+OBJS = topology.o
+
+default: cpu_topology
+
+cpu_topology: $(OBJS)
+	$(CC) ${CFLAGS} $(OBJS) -lncurses -o $@
+
+clean:
+	rm -f $(OBJS) cpu_topology
diff --git a/list.h b/list.h
new file mode 100644
index 0000000..e2d79b1
--- /dev/null
+++ b/list.h
@@ -0,0 +1,561 @@
+#ifndef _LINUX_LIST_H
+#define _LINUX_LIST_H
+
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+
+#define LIST_POISON1 ((void *)0x00100100)
+#define LIST_POISON2 ((void *)0x00200200)
+
+struct list_head {
+	struct list_head *next, *prev;
+};
+
+/*
+ * Simple doubly linked list implementation.
+ *
+ * Some of the internal functions ("__xxx") are useful when
+ * manipulating whole lists rather than single entries, as
+ * sometimes we already know the next/prev entries and we can
+ * generate better code by using them directly rather than
+ * using the generic single-entry routines.
+ */
+
+#define LIST_HEAD_INIT(name) { &(name), &(name) }
+
+#define LIST_HEAD(name) \
+	struct list_head name = LIST_HEAD_INIT(name)
+
+static inline void INIT_LIST_HEAD(struct list_head *list)
+{
+	list->next = list;
+	list->prev = list;
+}
+
+/*
+ * Insert a new entry between two known consecutive entries.
+ *
+ * This is only for internal list manipulation where we know
+ * the prev/next entries already!
+ */
+static inline void __list_add(struct list_head *new,
+			      struct list_head *prev,
+			      struct list_head *next)
+{
+	next->prev = new;
+	new->next = next;
+	new->prev = prev;
+	prev->next = new;
+}
+
+/**
+ * list_add - add a new entry
+ * @new: new entry to be added
+ * @head: list head to add it after
+ *
+ * Insert a new entry after the specified head.
+ * This is good for implementing stacks.
+ */
+static inline void list_add(struct list_head *new, struct list_head *head)
+{
+	__list_add(new, head, head->next);
+}
+
+
+/**
+ * list_add_tail - add a new entry
+ * @new: new entry to be added
+ * @head: list head to add it before
+ *
+ * Insert a new entry before the specified head.
+ * This is useful for implementing queues.
+ */
+static inline void list_add_tail(struct list_head *new, struct list_head *head)
+{
+	__list_add(new, head->prev, head);
+}
+
+/*
+ * Delete a list entry by making the prev/next entries
+ * point to each other.
+ *
+ * This is only for internal list manipulation where we know
+ * the prev/next entries already!
+ */
+static inline void __list_del(struct list_head *prev, struct list_head *next)
+{
+	next->prev = prev;
+	prev->next = next;
+}
+
+/**
+ * list_del - deletes entry from list.
+ * @entry: the element to delete from the list.
+ * Note: list_empty() on entry does not return true after this, the entry is
+ * in an undefined state.
+ */
+static inline void __list_del_entry(struct list_head *entry)
+{
+	__list_del(entry->prev, entry->next);
+}
+
+static inline void list_del(struct list_head *entry)
+{
+	__list_del(entry->prev, entry->next);
+	entry->next = LIST_POISON1;
+	entry->prev = LIST_POISON2;
+}
+
+/**
+ * list_replace - replace old entry by new one
+ * @old : the element to be replaced
+ * @new : the new element to insert
+ *
+ * If @old was empty, it will be overwritten.
+ */
+static inline void list_replace(struct list_head *old,
+				struct list_head *new)
+{
+	new->next = old->next;
+	new->next->prev = new;
+	new->prev = old->prev;
+	new->prev->next = new;
+}
+
+static inline void list_replace_init(struct list_head *old,
+					struct list_head *new)
+{
+	list_replace(old, new);
+	INIT_LIST_HEAD(old);
+}
+
+/**
+ * list_del_init - deletes entry from list and reinitialize it.
+ * @entry: the element to delete from the list.
+ */
+static inline void list_del_init(struct list_head *entry)
+{
+	__list_del_entry(entry);
+	INIT_LIST_HEAD(entry);
+}
+
+/**
+ * list_move - delete from one list and add as another's head
+ * @list: the entry to move
+ * @head: the head that will precede our entry
+ */
+static inline void list_move(struct list_head *list, struct list_head *head)
+{
+	__list_del_entry(list);
+	list_add(list, head);
+}
+
+/**
+ * list_move_tail - delete from one list and add as another's tail
+ * @list: the entry to move
+ * @head: the head that will follow our entry
+ */
+static inline void list_move_tail(struct list_head *list,
+				  struct list_head *head)
+{
+	__list_del_entry(list);
+	list_add_tail(list, head);
+}
+
+/**
+ * list_is_last - tests whether @list is the last entry in list @head
+ * @list: the entry to test
+ * @head: the head of the list
+ */
+static inline int list_is_last(const struct list_head *list,
+				const struct list_head *head)
+{
+	return list->next == head;
+}
+
+/**
+ * list_empty - tests whether a list is empty
+ * @head: the list to test.
+ */
+static inline int list_empty(const struct list_head *head)
+{
+	return head->next == head;
+}
+
+/**
+ * list_empty_careful - tests whether a list is empty and not being modified
+ * @head: the list to test
+ *
+ * Description:
+ * tests whether a list is empty _and_ checks that no other CPU might be
+ * in the process of modifying either member (next or prev)
+ *
+ * NOTE: using list_empty_careful() without synchronization
+ * can only be safe if the only activity that can happen
+ * to the list entry is list_del_init(). Eg. it cannot be used
+ * if another CPU could re-list_add() it.
+ */
+static inline int list_empty_careful(const struct list_head *head)
+{
+	struct list_head *next = head->next;
+	return (next == head) && (next == head->prev);
+}
+
+/**
+ * list_rotate_left - rotate the list to the left
+ * @head: the head of the list
+ */
+static inline void list_rotate_left(struct list_head *head)
+{
+	struct list_head *first;
+
+	if (!list_empty(head)) {
+		first = head->next;
+		list_move_tail(first, head);
+	}
+}
+
+/**
+ * list_is_singular - tests whether a list has just one entry.
+ * @head: the list to test.
+ */
+static inline int list_is_singular(const struct list_head *head)
+{
+	return !list_empty(head) && (head->next == head->prev);
+}
+
+static inline void __list_cut_position(struct list_head *list,
+		struct list_head *head, struct list_head *entry)
+{
+	struct list_head *new_first = entry->next;
+	list->next = head->next;
+	list->next->prev = list;
+	list->prev = entry;
+	entry->next = list;
+	head->next = new_first;
+	new_first->prev = head;
+}
+
+/**
+ * list_cut_position - cut a list into two
+ * @list: a new list to add all removed entries
+ * @head: a list with entries
+ * @entry: an entry within head, could be the head itself
+ *	and if so we won't cut the list
+ *
+ * This helper moves the initial part of @head, up to and
+ * including @entry, from @head to @list. You should
+ * pass on @entry an element you know is on @head. @list
+ * should be an empty list or a list you do not care about
+ * losing its data.
+ *
+ */
+static inline void list_cut_position(struct list_head *list,
+		struct list_head *head, struct list_head *entry)
+{
+	if (list_empty(head))
+		return;
+	if (list_is_singular(head) &&
+		(head->next != entry && head != entry))
+		return;
+	if (entry == head)
+		INIT_LIST_HEAD(list);
+	else
+		__list_cut_position(list, head, entry);
+}
+
+static inline void __list_splice(const struct list_head *list,
+				 struct list_head *prev,
+				 struct list_head *next)
+{
+	struct list_head *first = list->next;
+	struct list_head *last = list->prev;
+
+	first->prev = prev;
+	prev->next = first;
+
+	last->next = next;
+	next->prev = last;
+}
+
+/**
+ * list_splice - join two lists, this is designed for stacks
+ * @list: the new list to add.
+ * @head: the place to add it in the first list.
+ */
+static inline void list_splice(const struct list_head *list,
+				struct list_head *head)
+{
+	if (!list_empty(list))
+		__list_splice(list, head, head->next);
+}
+
+/**
+ * list_splice_tail - join two lists, each list being a queue
+ * @list: the new list to add.
+ * @head: the place to add it in the first list.
+ */
+static inline void list_splice_tail(struct list_head *list,
+				struct list_head *head)
+{
+	if (!list_empty(list))
+		__list_splice(list, head->prev, head);
+}
+
+/**
+ * list_splice_init - join two lists and reinitialise the emptied list.
+ * @list: the new list to add.
+ * @head: the place to add it in the first list.
+ *
+ * The list at @list is reinitialised
+ */
+static inline void list_splice_init(struct list_head *list,
+				    struct list_head *head)
+{
+	if (!list_empty(list)) {
+		__list_splice(list, head, head->next);
+		INIT_LIST_HEAD(list);
+	}
+}
+
+/**
+ * list_splice_tail_init - join two lists and reinitialise the emptied list
+ * @list: the new list to add.
+ * @head: the place to add it in the first list.
+ *
+ * Each of the lists is a queue.
+ * The list at @list is reinitialised
+ */
+static inline void list_splice_tail_init(struct list_head *list,
+					 struct list_head *head)
+{
+	if (!list_empty(list)) {
+		__list_splice(list, head->prev, head);
+		INIT_LIST_HEAD(list);
+	}
+}
+
+#define offsetof(s, m)      ((size_t)&(((s *)0)->m))
+
+#define container_of(ptr, type, member) ({			\
+	const typeof(((type *)0)->member) * __mptr = (ptr);	\
+	(type *)((char *)__mptr - offsetof(type, member)); })
+
+/**
+ * list_entry - get the struct for this entry
+ * @ptr:	the &struct list_head pointer.
+ * @type:	the type of the struct this is embedded in.
+ * @member:	the name of the list_struct within the struct.
+ */
+#define list_entry(ptr, type, member) \
+	container_of(ptr, type, member)
+
+/**
+ * list_first_entry - get the first element from a list
+ * @ptr:	the list head to take the element from.
+ * @type:	the type of the struct this is embedded in.
+ * @member:	the name of the list_struct within the struct.
+ *
+ * Note, that list is expected to be not empty.
+ */
+#define list_first_entry(ptr, type, member) \
+	list_entry((ptr)->next, type, member)
+
+/**
+ * list_for_each	-	iterate over a list
+ * @pos:	the &struct list_head to use as a loop cursor.
+ * @head:	the head for your list.
+ */
+#define list_for_each(pos, head) \
+	for (pos = (head)->next; pos != (head); pos = pos->next)
+
+/**
+ * __list_for_each	-	iterate over a list
+ * @pos:	the &struct list_head to use as a loop cursor.
+ * @head:	the head for your list.
+ *
+ * This variant doesn't differ from list_for_each() any more.
+ * We don't do prefetching in either case.
+ */
+#define __list_for_each(pos, head) \
+	for (pos = (head)->next; pos != (head); pos = pos->next)
+
+/**
+ * list_for_each_prev	-	iterate over a list backwards
+ * @pos:	the &struct list_head to use as a loop cursor.
+ * @head:	the head for your list.
+ */
+#define list_for_each_prev(pos, head) \
+	for (pos = (head)->prev; pos != (head); pos = pos->prev)
+
+/**
+ * list_for_each_safe - iterate over a list safe against removal of list entry
+ * @pos:	the &struct list_head to use as a loop cursor.
+ * @n:		another &struct list_head to use as temporary storage
+ * @head:	the head for your list.
+ */
+#define list_for_each_safe(pos, n, head) \
+	for (pos = (head)->next, n = pos->next; pos != (head); \
+		pos = n, n = pos->next)
+
+/**
+ * list_for_each_prev_safe - iterate over a list backwards safe against removal of list entry
+ * @pos:	the &struct list_head to use as a loop cursor.
+ * @n:		another &struct list_head to use as temporary storage
+ * @head:	the head for your list.
+ */
+#define list_for_each_prev_safe(pos, n, head) \
+	for (pos = (head)->prev, n = pos->prev; \
+	     pos != (head); \
+	     pos = n, n = pos->prev)
+
+/**
+ * list_for_each_entry	-	iterate over list of given type
+ * @pos:	the type * to use as a loop cursor.
+ * @head:	the head for your list.
+ * @member:	the name of the list_struct within the struct.
+ */
+#define list_for_each_entry(pos, head, member)				\
+	for (pos = list_entry((head)->next, typeof(*pos), member);	\
+	     &pos->member != (head);	\
+	     pos = list_entry(pos->member.next, typeof(*pos), member))
+
+/**
+ * list_for_each_entry_reverse - iterate backwards over list of given type.
+ * @pos:	the type * to use as a loop cursor.
+ * @head:	the head for your list.
+ * @member:	the name of the list_struct within the struct.
+ */
+#define list_for_each_entry_reverse(pos, head, member)			\
+	for (pos = list_entry((head)->prev, typeof(*pos), member);	\
+	     &pos->member != (head);	\
+	     pos = list_entry(pos->member.prev, typeof(*pos), member))
+
+/**
+ * list_prepare_entry - prepare a entry for use in list_for_each_entry_continue()
+ * @pos:	the type * to use as a start point
+ * @head:	the head of the list
+ * @member:	the name of the list_struct within the struct.
+ *
+ * Prepares a entry for use as a start point in list_for_each_entry_continue().
+ */
+#define list_prepare_entry(pos, head, member) \
+	((pos) ? : list_entry(head, typeof(*pos), member))
+
+/**
+ * list_for_each_entry_continue - continue iteration over list of given type
+ * @pos:	the type * to use as a loop cursor.
+ * @head:	the head for your list.
+ * @member:	the name of the list_struct within the struct.
+ *
+ * Continue to iterate over list of given type, continuing after
+ * the current position.
+ */
+#define list_for_each_entry_continue(pos, head, member)		\
+	for (pos = list_entry(pos->member.next, typeof(*pos), member);	\
+	     &pos->member != (head);	\
+	     pos = list_entry(pos->member.next, typeof(*pos), member))
+
+/**
+ * list_for_each_entry_continue_reverse - iterate backwards from the given point
+ * @pos:	the type * to use as a loop cursor.
+ * @head:	the head for your list.
+ * @member:	the name of the list_struct within the struct.
+ *
+ * Start to iterate over list of given type backwards, continuing after
+ * the current position.
+ */
+#define list_for_each_entry_continue_reverse(pos, head, member)		\
+	for (pos = list_entry(pos->member.prev, typeof(*pos), member);	\
+	     &pos->member != (head);	\
+	     pos = list_entry(pos->member.prev, typeof(*pos), member))
+
+/**
+ * list_for_each_entry_from - iterate over list of given type from the current point
+ * @pos:	the type * to use as a loop cursor.
+ * @head:	the head for your list.
+ * @member:	the name of the list_struct within the struct.
+ *
+ * Iterate over list of given type, continuing from current position.
+ */
+#define list_for_each_entry_from(pos, head, member)			\
+	for (; &pos->member != (head);	\
+	     pos = list_entry(pos->member.next, typeof(*pos), member))
+
+/**
+ * list_for_each_entry_safe - iterate over list of given type safe against removal of list entry
+ * @pos:	the type * to use as a loop cursor.
+ * @n:		another type * to use as temporary storage
+ * @head:	the head for your list.
+ * @member:	the name of the list_struct within the struct.
+ */
+#define list_for_each_entry_safe(pos, n, head, member)			\
+	for (pos = list_entry((head)->next, typeof(*pos), member),	\
+		n = list_entry(pos->member.next, typeof(*pos), member);	\
+	     &pos->member != (head);					\
+	     pos = n, n = list_entry(n->member.next, typeof(*n), member))
+
+/**
+ * list_for_each_entry_safe_continue - continue list iteration safe against removal
+ * @pos:	the type * to use as a loop cursor.
+ * @n:		another type * to use as temporary storage
+ * @head:	the head for your list.
+ * @member:	the name of the list_struct within the struct.
+ *
+ * Iterate over list of given type, continuing after current point,
+ * safe against removal of list entry.
+ */
+#define list_for_each_entry_safe_continue(pos, n, head, member)		\
+	for (pos = list_entry(pos->member.next, typeof(*pos), member),	\
+		n = list_entry(pos->member.next, typeof(*pos), member);	\
+	     &pos->member != (head);					\
+	     pos = n, n = list_entry(n->member.next, typeof(*n), member))
+
+/**
+ * list_for_each_entry_safe_from - iterate over list from current point safe against removal
+ * @pos:	the type * to use as a loop cursor.
+ * @n:		another type * to use as temporary storage
+ * @head:	the head for your list.
+ * @member:	the name of the list_struct within the struct.
+ *
+ * Iterate over list of given type from current point, safe against
+ * removal of list entry.
+ */
+#define list_for_each_entry_safe_from(pos, n, head, member)		\
+	for (n = list_entry(pos->member.next, typeof(*pos), member);	\
+	     &pos->member != (head);					\
+	     pos = n, n = list_entry(n->member.next, typeof(*n), member))
+
+/**
+ * list_for_each_entry_safe_reverse - iterate backwards over list safe against removal
+ * @pos:	the type * to use as a loop cursor.
+ * @n:		another type * to use as temporary storage
+ * @head:	the head for your list.
+ * @member:	the name of the list_struct within the struct.
+ *
+ * Iterate backwards over list of given type, safe against removal
+ * of list entry.
+ */
+#define list_for_each_entry_safe_reverse(pos, n, head, member)		\
+	for (pos = list_entry((head)->prev, typeof(*pos), member),	\
+		n = list_entry(pos->member.prev, typeof(*pos), member);	\
+	     &pos->member != (head);					\
+	     pos = n, n = list_entry(n->member.prev, typeof(*n), member))
+
+/**
+ * list_safe_reset_next - reset a stale list_for_each_entry_safe loop
+ * @pos:	the loop cursor used in the list_for_each_entry_safe loop
+ * @n:		temporary storage used in list_for_each_entry_safe
+ * @member:	the name of the list_struct within the struct.
+ *
+ * list_safe_reset_next is not safe to use in general if the list may be
+ * modified concurrently (eg. the lock is dropped in the loop body). An
+ * exception to this is if the cursor element (pos) is pinned in the list,
+ * and list_safe_reset_next is called after re-taking the lock and before
+ * completing the current iteration of the loop body.
+ */
+#define list_safe_reset_next(pos, n, member)				\
+	(n = list_entry(pos->member.next, typeof(*pos), member))
+
+#endif
diff --git a/topology.c b/topology.c
new file mode 100644
index 0000000..ae72dd9
--- /dev/null
+++ b/topology.c
@@ -0,0 +1,368 @@
+/*****************************************************************************
+ * Copyright (C) 2013, Linaro Limited.
+ *
+ * This file is part of cpu_topology.
+ *
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Shaojie Sun <shaojie.sun@linaro.org> (Hislicon technologies)
+ *       - initial API and implementation
+ *
+ *****************************************************************************/
+
+#define  _GNU_SOURCE
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <stdbool.h>
+#include <unistd.h>
+#include <string.h>
+#include <dirent.h>
+#include <ctype.h>
+#include <sys/stat.h>
+
+#include "list.h"
+
+struct cpu_cpu {
+	struct list_head list_cpu;
+	int cpu_id;
+	void *pcpu_info;	/* this point will point to cpu info */
+};
+
+struct cpu_core {
+	struct list_head list_core;
+	int core_id;
+	struct list_head cpu_head;
+	int cpu_num;
+	bool is_ht;
+};
+
+struct cpu_physical {
+	struct list_head list_physical;
+	int physical_id;
+	struct list_head core_head;
+	int core_num;
+};
+
+struct cpu_topology {
+	struct list_head physical_head;
+	int physical_num;
+};
+
+struct cpu_topology g_cpu_topo_list;
+
+struct topology_info {
+	int physical_id;
+	int core_id;
+	int cpu_id;
+	int thread_siblings;
+};
+
+struct list_info {
+	struct list_head hlist;
+	int id;
+};
+
+struct list_head *check_exist_from_head(struct list_head *head, int id)
+{
+	struct list_head *tmp;
+
+	list_for_each(tmp, head) {
+		if (id == ((struct list_info *)tmp)->id)
+			return tmp;
+	}
+
+	return NULL;
+}
+
+struct list_head *check_pos_from_head(struct list_head *head, int id)
+{
+	struct list_head *tmp;
+
+	list_for_each(tmp, head) {
+		if (id < ((struct list_info *)tmp)->id)
+			break;
+	}
+
+	return tmp->prev;
+}
+
+int add_topo_info(struct cpu_topology *topo_list, struct topology_info *info)
+{
+	struct cpu_physical *s_phy;
+	struct cpu_core     *s_core;
+	struct cpu_cpu      *s_cpu = NULL;
+	struct list_head    *ptr;
+
+	s_cpu = malloc(sizeof(struct cpu_cpu));
+	if (!s_cpu)
+		return -1;
+
+	s_cpu->cpu_id = info->cpu_id;
+
+	/* add cpu physical info */
+	ptr = check_exist_from_head(&topo_list->physical_head,
+					info->physical_id);
+	if (!ptr) {
+		s_phy = malloc(sizeof(struct cpu_physical));
+		if (!s_phy)
+			return -1;
+
+		s_phy->core_num = 0;
+		s_phy->physical_id = info->physical_id;
+		INIT_LIST_HEAD(&s_phy->core_head);
+
+		ptr = check_pos_from_head(&topo_list->physical_head,
+						s_phy->physical_id);
+		list_add(&s_phy->list_physical, ptr);
+		topo_list->physical_num++;
+	} else {
+		s_phy = list_entry(ptr, struct cpu_physical,
+						list_physical);
+	}
+
+	/* add cpu core info */
+	ptr = check_exist_from_head(&s_phy->core_head, info->core_id);
+	if (!ptr) {
+		s_core = malloc(sizeof(struct cpu_physical));
+		if (!s_core)
+			return -1;
+
+		s_core->cpu_num = 0;
+		s_core->is_ht = false;
+		s_core->core_id = info->core_id;
+		INIT_LIST_HEAD(&s_core->cpu_head);
+
+		ptr = check_pos_from_head(&s_phy->core_head,
+						s_core->core_id);
+		list_add(&s_core->list_core, ptr);
+		s_phy->core_num++;
+
+	} else {
+		s_core = list_entry(ptr, struct cpu_core, list_core);
+	}
+
+	/* add cpu info */
+	ptr = check_pos_from_head(&s_core->cpu_head, s_cpu->cpu_id);
+	list_add(&s_cpu->list_cpu, ptr);
+	s_core->cpu_num++;
+	if (s_core->cpu_num > 1)
+		s_core->is_ht = true;
+
+	return 0;
+}
+
+void free_cpu_cpu_list(struct list_head *head)
+{
+	struct cpu_cpu *lcpu, *n;
+
+	list_for_each_entry_safe(lcpu, n, head, list_cpu) {
+		list_del(&lcpu->list_cpu);
+		free(lcpu);
+	}
+}
+
+void free_cpu_core_list(struct list_head *head)
+{
+	struct cpu_core *lcore, *n;
+
+	list_for_each_entry_safe(lcore, n, head, list_core) {
+		free_cpu_cpu_list(&lcore->cpu_head);
+		list_del(&lcore->list_core);
+		free(lcore);
+	}
+}
+
+void free_cpu_topology(struct list_head *head)
+{
+	struct cpu_physical *lphysical, *n;
+
+	list_for_each_entry_safe(lphysical, n, head, list_physical) {
+		free_cpu_core_list(&lphysical->core_head);
+		list_del(&lphysical->list_physical);
+		free(lphysical);
+	}
+}
+
+int output_topo_info(struct cpu_topology *topo_list)
+{
+	struct cpu_physical *s_phy;
+	struct cpu_core     *s_core;
+	struct cpu_cpu      *s_cpu;
+
+	list_for_each_entry(s_phy, &topo_list->physical_head, list_physical) {
+		printf("Cluster%c:\n", s_phy->physical_id + 'A');
+		list_for_each_entry(s_core, &s_phy->core_head, list_core) {
+			if (s_core->is_ht) {
+				printf("\tCore%d\n", s_core->core_id);
+				list_for_each_entry(s_cpu, &s_core->cpu_head, list_cpu)
+					printf("\t\tCPU%d\n", s_cpu->cpu_id);
+			} else {
+				list_for_each_entry(s_cpu, &s_core->cpu_head, list_cpu)
+					printf("\tCPU%d\n", s_cpu->cpu_id);
+			}
+		}
+	}
+
+	return 0;
+}
+
+/*
+ * This functions is a helper to read a specific file content and store
+ * the content inside a variable pointer passed as parameter, the format
+ * parameter gives the variable type to be read from the file.
+ *
+ * @path : directory path containing the file
+ * @name : name of the file to be read
+ * @format : the format of the format
+ * @value : a pointer to a variable to store the content of the file
+ * Returns 0 on success, -1 otherwise
+ */
+int file_read_value(const char *path, const char *name,
+			const char *format, void *value)
+{
+	FILE *file;
+	char *rpath;
+	int ret;
+
+	ret = asprintf(&rpath, "%s/%s", path, name);
+	if (ret < 0)
+		return ret;
+
+	file = fopen(rpath, "r");
+	if (!file) {
+		ret = -1;
+		goto out_free;
+	}
+
+	ret = fscanf(file, format, value) == EOF ? -1 : 0;
+
+	fclose(file);
+out_free:
+	free(rpath);
+	return ret;
+}
+
+static inline int read_topology_cb(char *path, struct topology_info *info)
+{
+	file_read_value(path, "core_id", "%d", &info->core_id);
+	file_read_value(path, "physical_package_id", "%d", &info->physical_id);
+
+	return 0;
+}
+
+typedef int (*folder_filter_t)(const char *name);
+
+static int cpu_filter_cb(const char *name)
+{
+	/* let's ignore some directories in order to avoid to be
+	 * pulled inside the sysfs circular symlinks mess/hell
+	 * (choose the word which fit better)*/
+	if (!strcmp(name, "cpuidle"))
+		return 1;
+
+	if (!strcmp(name, "cpufreq"))
+		return 1;
+
+	return 0;
+}
+
+/*
+ * This function will browse the directory structure and build a
+ * reflecting the content of the directory tree.
+ *
+ * @path   : the root node of the folder
+ * @filter : a callback to filter out the directories
+ * Returns 0 on success, -1 otherwise
+ */
+static int folder_scan(char *path, folder_filter_t filter)
+{
+	DIR *dir, *dir_topology;
+	char *basedir, *newpath;
+	struct dirent dirent, *direntp;
+	struct stat s;
+	int ret = 0;
+
+	dir = opendir(path);
+	if (!dir) {
+		printf("error: unable to open directory %s\n", path);
+		return -1;
+	}
+
+	ret = asprintf(&basedir, "%s", path);
+	if (ret < 0)
+		return -1;
+
+	ret = basename(basedir) ? 0 : -1;
+	if (ret < 0)
+		goto out_free_basedir;
+
+	while (!readdir_r(dir, &dirent, &direntp)) {
+
+		if (!direntp)
+			break;
+
+		if (direntp->d_name[0] == '.')
+			continue;
+
+		if (filter && filter(direntp->d_name))
+			continue;
+
+		if (!strstr(direntp->d_name, "cpu"))
+			continue;
+
+		ret = asprintf(&newpath, "%s/%s/%s", basedir,
+				direntp->d_name, "topology");
+		if (ret < 0)
+			goto out_free_basedir;
+
+		ret = stat(newpath, &s);
+		if (ret)
+			goto out_free_newpath;
+
+		if (S_ISDIR(s.st_mode) || (S_ISLNK(s.st_mode))) {
+			struct topology_info cpu_info;
+
+			dir_topology = opendir(path);
+			if (!dir_topology)
+				continue;
+
+			read_topology_cb(newpath, &cpu_info);
+			sscanf(direntp->d_name, "cpu%d", &cpu_info.cpu_id);
+			add_topo_info(&g_cpu_topo_list, &cpu_info);
+		}
+
+	out_free_newpath:
+		free(newpath);
+
+		if (ret)
+			break;
+	}
+
+out_free_basedir:
+	free(basedir);
+
+	closedir(dir);
+
+	return ret;
+}
+
+int main(int argc, char *argv[])
+{
+	INIT_LIST_HEAD(&g_cpu_topo_list.physical_head);
+	g_cpu_topo_list.physical_num = 0;
+
+	folder_scan("/sys/devices/system/cpu", cpu_filter_cb);
+
+	output_topo_info(&g_cpu_topo_list);
+
+	/* free alloced memory */
+	free_cpu_topology(&g_cpu_topo_list.physical_head);
+
+	return 0;
+}
+